

// SystemJS support.
window.self = window;
require("src/system.bundle.js");

const importMapJson = jsb.fileUtils.getStringFromFile("src/import-map.json");
const importMap = JSON.parse(importMapJson);
System.warmup({
    importMap,
    importMapUrl: 'src/import-map.json',
    defaultHandler: (urlNoSchema) => {
        require(urlNoSchema.startsWith('/') ? urlNoSchema.substr(1) : urlNoSchema);
    },
});

System.import('./src/application.js')
.then(({ Application }) => {
    return new Application();
}).then((application) => {
    return System.import('cc').then((cc) => {
        
        require('jsb-adapter/engine-adapter.js');
        let paths = [];
        if(cc.sys.os == cc.sys.OS.IOS) {
            paths = jsb.fileUtils.getSearchPaths();
        }
        if (typeof cc != 'undefined' && cc.sys.isNative) {
            let versionPath = jsb.fileUtils.getWritablePath() + 'VERSION';
            var storagePath = jsb.fileUtils.getWritablePath() + 'remote-assets/';
            paths.push(storagePath);
            console.log('111111111')
            let nowVersion;
            if(cc.sys.os == cc.sys.OS.ANDROID){
                console.log('222222222')
                nowVersion = jsb.reflection.callStaticMethod("com/cocos/game/AppCcActivity", "getVersionCode", "()Ljava/lang/String;") || 'undefined';
            } else if(cc.sys.os == cc.sys.OS.IOS){
                console.log('333333333')
                nowVersion = jsb.reflection.callStaticMethod("ViewController", "getVersionCode") || 'undefined';
            }
            console.log('NOW-VERSION:', nowVersion);
            if (!jsb.fileUtils.isFileExist(versionPath)) {
                console.log('init base version')
                jsb.fileUtils.writeStringToFile(nowVersion, versionPath);
            } else {
                console.log('check old version')
                let oldVersion = jsb.fileUtils.getStringFromFile(versionPath);
                if (oldVersion != nowVersion) {
                    jsb.fileUtils.removeDirectory(storagePath);
                    jsb.fileUtils.writeStringToFile(nowVersion, versionPath);
                    console.log('DIFF-VERSION-CLEAN');
                }
            }
        };
        paths.push("@assets/");
        jsb.fileUtils.setSearchPaths(paths);
        
        return application.init(cc);
    }).then(() => {
        return application.start();
    });
}).catch((err) => {
    console.error(err.toString() + ', stack: ' + err.stack);
});
